program NkV;

uses Windows, Messages, NSys, NLib, NUtil, NForm, MainForm, ImgFilter;

{$R *.RES}

var
  Form: TNkVMainForm;
  list: TFileList;
  i: Integer;
  fname: string;
  loadpos: Boolean;
begin
  AppName := 'NkV';
  ProfDir := GetEnv('NKTOOLSPROF', '');
  if ProfDir = '' then
    ProfDir := DirName(AbsPath(Argv[0]))
  else
    ProfDir := JoinPath(ProfDir, Lower(AppName));
  About := AppName+' 0.7 (2006-11-23)'+EOL+EOL+
    'Copyright (C) 1999-2006 Nobuyuki Honda (Ferdia)'+EOL+EOL+
    'This software is provided under the zlib/libpng license.'+EOL+EOL+
    'Profile Folder: '+ProfDir;

  loadpos := FindWindow(PChar(string(TNkVMainForm.ClassName)), nil) = 0;

  list := TFileList.Create;
  Form := TNkVMainForm.CreateDefaultPos(AppName, 320, 240);
  try
    SetMainForm(Form);

    if loadpos then
    begin
      LoadFormPos(ProfDir, Form);  
      // override size
      Form.SetSize(320, 240);
    end;

    for i := 1 to Argc-1 do
      if IsDir(Argv[i]) then
      begin
        Form.DirMode := Argc = 2;
        with TListDir.Create(Argv[i]) do
          try
            while Each(fname) do
              if not IsDir then
                list.Add(AbsPath(JoinPath(Argv[i], fname)));
          finally
            Free;
          end
      end else
        list.Add(AbsPath(Argv[i]));
    list.Sort(StrColl);
    if list.Count = 0 then // stdin
      list.Add('');
    Form.LoadFirstFile(list);
    list.Free;
    if Form.FileList.Count = 0 then // no lodable file
    begin
      ExitCode := 1;
      Exit;
    end;
    if (Form.FileList.Count = 1) and (Form.FileList[0] <> '') then // not stdin
    begin
      Form.DirMode := True;
      Form.FileListUpdate := True;
    end;
    
    Form.Show;
    ExitCode := MessageLoop;
  finally
    Form.Free;
  end;
end.
